' A sample form demonstrating virtual printer integration methods
' and print job information retrieval.

Imports System.Drawing.Printing
Imports System.Windows.Forms.Cursor
Imports System.Windows.Forms.MessageBox
Imports System.Environment
Imports System.IO
Imports System.Runtime.InteropServices
Imports Microsoft.Win32
Imports System.Diagnostics.Process
Imports System.Text

' Print job info transfer modes
Public Enum TransferModes
    ThroughCommandLine = 0
    ThroughCopydata = 1
    ThroughClipboard = 2
End Enum


Public Class SampleForm
    Inherits System.Windows.Forms.Form

    Private Const _sPrinterName As String = "Your Virtual Printer Example"
    Private Const _sRegistryKey As String = "Your Virtual Printer Example"

	Private Const _sMsgBoxCaption As String = _sPrinterName & " (VB.NET)"

    Private _iTransferMode As Integer = TransferModes.ThroughCommandLine
    Private _iMessageID As Integer = -1
    Private _sClipboardFormat As String
    Private _sInputIniFilePath As String

    ' GDI constants defines
    Private Const WM_COPYDATA As Integer = &H4A
    Private Const DC_PAPERS As Integer = 2
    Private Const DC_PAPERNAMES As Integer = 16
    Friend WithEvents Button_About As System.Windows.Forms.Button
    Private Const DC_PAPERSIZE As Integer = 3

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ButtonClose As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents Button_PrinterPreferences As System.Windows.Forms.Button
    Private WithEvents ListBox As System.Windows.Forms.ListBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(SampleForm))
        Me.ButtonClose = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.ListBox = New System.Windows.Forms.ListBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.Button_PrinterPreferences = New System.Windows.Forms.Button
        Me.Button_About = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'ButtonClose
        '
        Me.ButtonClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ButtonClose.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.ButtonClose.Location = New System.Drawing.Point(366, 378)
        Me.ButtonClose.Name = "ButtonClose"
        Me.ButtonClose.Size = New System.Drawing.Size(85, 25)
        Me.ButtonClose.TabIndex = 1
        Me.ButtonClose.Text = "Close"
        '
        'Label1
        '
        Me.Label1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Label1.Location = New System.Drawing.Point(7, 6)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(443, 39)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "This is a sample of application demonstrating the info on the printed document. T" & _
            "he info is given by the printer via special .INI file. See the source code of th" & _
            "e sample in the installation folder."
        '
        'ListBox
        '
        Me.ListBox.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.ListBox.IntegralHeight = False
        Me.ListBox.Location = New System.Drawing.Point(7, 50)
        Me.ListBox.Name = "ListBox"
        Me.ListBox.Size = New System.Drawing.Size(443, 266)
        Me.ListBox.TabIndex = 3
        '
        'Label2
        '
        Me.Label2.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Label2.Location = New System.Drawing.Point(7, 318)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(443, 17)
        Me.Label2.TabIndex = 4
        Me.Label2.Text = "* Double click on the line containing file path to open the file with the default" & _
            " application."
        '
        'GroupBox1
        '
        Me.GroupBox1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.GroupBox1.Location = New System.Drawing.Point(7, 333)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(443, 9)
        Me.GroupBox1.TabIndex = 6
        Me.GroupBox1.TabStop = False
        '
        'Button_PrinterPreferences
        '
        Me.Button_PrinterPreferences.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.Button_PrinterPreferences.Location = New System.Drawing.Point(7, 346)
        Me.Button_PrinterPreferences.Name = "Button_PrinterPreferences"
        Me.Button_PrinterPreferences.Size = New System.Drawing.Size(123, 25)
        Me.Button_PrinterPreferences.TabIndex = 7
        Me.Button_PrinterPreferences.Text = "Printer Preferences"
        '
        'Button_About
        '
        Me.Button_About.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Button_About.Location = New System.Drawing.Point(136, 346)
        Me.Button_About.Name = "Button_About"
        Me.Button_About.Size = New System.Drawing.Size(315, 25)
        Me.Button_About.TabIndex = 8
        Me.Button_About.Text = "Find more about Custom Virtual Printer Drivers service"
        Me.Button_About.UseVisualStyleBackColor = True
        '
        'SampleForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(457, 410)
        Me.Controls.Add(Me.Button_About)
        Me.Controls.Add(Me.Button_PrinterPreferences)
        Me.Controls.Add(Me.GroupBox1)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.ListBox)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.ButtonClose)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "SampleForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Sample Client Application for "
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub SampleForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' set unique window title
        Text = "Sample Client Application for " & _sPrinterName

        ' Get printer configuration settings related to the Transfer Mode:

        Dim regKey As RegistryKey

        regKey = Registry.LocalMachine.OpenSubKey("Software\\" & _sRegistryKey)
        If Not regKey Is Nothing Then
            _iTransferMode = regKey.GetValue("Transfer Mode", TransferModes.ThroughCommandLine)
            _iMessageID = regKey.GetValue("Message ID", -1)
            _sClipboardFormat = regKey.GetValue("Clipboard Format", "")
        End If


        ' if transfer mode is command line mode then get print job info from command line
        If _iTransferMode = TransferModes.ThroughCommandLine Then

            _sInputIniFilePath = Microsoft.VisualBasic.Command()

            If Not File.Exists(_sInputIniFilePath) Then
                ListBox.Items.Add("Invalid command line parameter!")
                Return
            End If

            FillInfo()

        Else : ListBox.Items.Add("Waiting for a print job...")

        End If

    End Sub

    Private Sub FillInfo()

        Dim bytebuf As Array = Array.CreateInstance(GetType(Byte), 512)
        Dim sTemp As String
        Dim iCount, i As Integer
        Dim iHorizontalResolution, iVerticalResoultion As Integer
        Dim iOrientation, iCopies, iCollate As Integer
        Dim iFormWidth, iFormHeight As Integer

        ListBox.Items.Clear()

        ' show the transfer mode:
        ListBox.Items.Add("Transfer mode = " & Microsoft.VisualBasic.Switch( _
            _iTransferMode = TransferModes.ThroughCommandLine, "Through the command line", _
            _iTransferMode = TransferModes.ThroughCopydata, "Through the WM_COPYDATA message", _
            _iTransferMode = TransferModes.ThroughClipboard, "Through the clipboard"))
        ListBox.Items.Add("")

        ListBox.Items.Add(_sInputIniFilePath)
        ListBox.Items.Add("")

        ' show device name:
        Win32.GetPrivateProfileStringA("Device", "DeviceName", "", bytebuf, 512, _sInputIniFilePath)
        ListBox.Items.Add("Device name = " & Encoding.ASCII.GetChars(bytebuf))

        ' show print job (document) name:
        Win32.GetPrivateProfileStringA("Document", "Name", "", bytebuf, 512, _sInputIniFilePath)
        ListBox.Items.Add("Document name = " & Encoding.ASCII.GetChars(bytebuf))

        ' show document resolution (dpi):
        iHorizontalResolution = Win32.GetPrivateProfileInt("Document", "HorizontalResolution", 0, _sInputIniFilePath)
        ListBox.Items.Add("Horizontal Resolution = " & iHorizontalResolution & "dpi")
        iVerticalResoultion = Win32.GetPrivateProfileInt("Document", "VerticalResolution", 0, _sInputIniFilePath)
        ListBox.Items.Add("Vertical Resolution = " & iVerticalResoultion & "dpi")

        ' show page orientation (1 - portrait, 2 - landscape):
        iOrientation = Win32.GetPrivateProfileInt("Document", "Orientation", 0, _sInputIniFilePath)
        If iOrientation = 1 Then : sTemp = "Portrait"
        ElseIf iOrientation = 2 Then : sTemp = "Landscape"
        Else : sTemp = "?"
        End If
        ListBox.Items.Add("Orientation = " & sTemp)

        ' show name and size of the paper form:
        Win32.GetPrivateProfileStringA("Document", "PaperSizeName", "", bytebuf, 512, _sInputIniFilePath)
        iFormWidth = Win32.GetPrivateProfileInt("Document", "PaperWidth", 0, _sInputIniFilePath)
        iFormHeight = Win32.GetPrivateProfileInt("Document", "PaperLength", 0, _sInputIniFilePath)
        ListBox.Items.Add("Paper Size = " & Encoding.ASCII.GetChars(bytebuf) & " (" & iFormWidth / 10 & "mm x " & iFormHeight / 10 & "mm)")

        ' show printer bin:
        Win32.GetPrivateProfileStringA("Document", "BinName", "", bytebuf, 512, _sInputIniFilePath)
        ListBox.Items.Add("Paper Bin = " & Encoding.ASCII.GetChars(bytebuf))
        
        ' show print job (document) page count:
        iCount = Win32.GetPrivateProfileInt("Document", "Pages", 0, _sInputIniFilePath)
        ListBox.Items.Add("Document Pages = " & iCount)

        ' show print job (document) copies count:
        iCopies = Win32.GetPrivateProfileInt("Document", "Copies", 0, _sInputIniFilePath)
        ListBox.Items.Add("Copies = " & iCopies)

        ' show print job (document) collate option:
        iCollate = Win32.GetPrivateProfileInt("Document", "Collate", 0, _sInputIniFilePath)
        If iCollate = 0 Then
            sTemp = "No"
        Else
            sTemp = "Yes"
        End If
        ListBox.Items.Add("Collate = " & sTemp)
        ListBox.Items.Add("")

        ' show paths of generated images files:

        Dim Types() As String = {"EMF", "BMP", "PNG", "JPEG", "TIFF", "PDF", "TXT", "SWF"}

        For Each sType As String In Types

            iCount = Win32.GetPrivateProfileInt(sType, "Count", 0, _sInputIniFilePath)

            If iCount > 0 Then

                ListBox.Items.Add(sType & " files (" & iCount & "):")

                For i = 0 To iCount - 1
                    Win32.GetPrivateProfileStringA(sType, String.Format("File{0}", i), "", bytebuf, 512, _sInputIniFilePath)
                    sTemp = Encoding.ASCII.GetChars(bytebuf)
                    ListBox.Items.Add(sTemp)
                Next i

                ListBox.Items.Add("")

            End If

        Next

    End Sub

    <System.Security.Permissions.PermissionSetAttribute(System.Security.Permissions.SecurityAction.Demand, Name:="FullTrust")> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        ' Listen for operating system messages

        If m.Msg = WM_COPYDATA Then ' analyze WM_COPYDATA message

            Dim Data As Win32.COPYDATASTRUCT

            Data = CType(m.GetLParam(GetType(Win32.COPYDATASTRUCT)), Win32.COPYDATASTRUCT)

            ' if message ID is equal to ID from the COPYDATASTRUCT then the message ahs been received from the virtual printer
            If Data.dwData.ToInt32() = _iMessageID Then

                _sInputIniFilePath = Marshal.PtrToStringAnsi(Data.lpData)
                FillInfo()
                BringToFront()

            End If

        ElseIf m.Msg >= &H8000 And m.Msg <= &HBFFF Then ' analyze all messages from WM_APP range

            If m.Msg = _iMessageID Then ' the message has been received from the virtual printer

                If _sClipboardFormat.Length = 0 Then
                    MsgBox("Configuration error: clipboard format is undefined.", MsgBoxStyle.OKOnly, _sMsgBoxCaption)
                End If

                ' register clipboard format
                Dim iClipboardFormat As Integer = Win32.RegisterClipboardFormat(_sClipboardFormat)

                If Win32.OpenClipboard(0) = 0 Then
                    MsgBox("Failed to open clipboard.", MsgBoxStyle.OKOnly, _sMsgBoxCaption)
                    Return
                End If

                ' get clipboard data of the registered format
                Dim hGlobal As IntPtr = Win32.GetClipboardData(iClipboardFormat)

                If IntPtr.Zero.Equals(hGlobal) Then
                    MsgBox("Failed to get clipboard data.", MsgBoxStyle.OKOnly, _sMsgBoxCaption)
                    Win32.CloseClipboard()
                    Return
                End If

                _sInputIniFilePath = Marshal.PtrToStringAnsi(hGlobal)

                Win32.CloseClipboard()

                FillInfo()

                BringToFront()

            End If

        End If

        MyBase.WndProc(m)

    End Sub

    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Application.Exit()

    End Sub

    Private Sub Button_PrinterPreferences_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_PrinterPreferences.Click

        Dim prc As New Process

        prc.StartInfo.FileName = "properties.exe"
        prc.StartInfo.UseShellExecute = True
        prc.StartInfo.WorkingDirectory = Path.GetDirectoryName(Application.ExecutablePath)

        Try
            prc.Start()
        Catch
            MessageBox.Show("File properties.exe not found in " + prc.StartInfo.WorkingDirectory, _sPrinterName)
        End Try

    End Sub

    Private Sub ListBox_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox.DoubleClick

        If ListBox.SelectedIndex <> -1 Then

            Try
                ' If the clicked item of the listbox contains path of file
                ' the file will be opened with default associated application.
                Process.Start(ListBox.SelectedItem)
            Catch
            End Try

        End If

    End Sub

    Private Sub Button_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_About.Click

        Application.UseWaitCursor = True

        Dim Proc As New Process

        Proc.StartInfo.FileName = "http://www.colorpilot.com/emfprinterpilot.html"
        Proc.StartInfo.Verb = "open"

        Try
            Proc.Start()
        Catch
        End Try

        Application.UseWaitCursor = False

    End Sub
End Class
